# Issue Prelude
**Please complete these steps and check these boxes (by putting an `x` inside 
the brackets) _before_ filing you issue:**

- [ ] I have read and understood CompleteParameter's [README][readme], 
  **especially the [Frequently Asked Questions][faq] section.**
- [ ] I have searched CompleteParameters's issue tracker to find issues similar 
  to the one I'm about to report and couldn't find an answer to my problem. 
- [ ] If filing a bug report, I have included the output of `vim --version`.
- [ ] If filing a bug report, I have included which OS (including specific OS
  version) I am using.
- [ ] If filing a bug report, I have attached the contents of log follow the steps.
  1. Execute `let g:complete_parameter_log_level = 1`.
  1. Replay you action.
  1. Execute `messages`.
  1. Copy the output and place it to next section. 
- [ ] If filing a bug report, I have included a minimal test case that reproduces
  my issue, including what I expected to happen and what actually happened.
- [ ] **I understand my issue may be closed if it becomes obvious I didn't
  actually perform all of these steps.**

Thank you for adhering to this process! It ensures your issue is resolved
quickly and that neither your nor our time is needlessly wasted.

# Issue Details
> Provide a clear description of the problem, including the following key
> questions:

* What did you do?

> Include steps to reproduce here.

> Include description of a minimal test case, including any actual code required
> to reproduce the issue.

* What did you expect to happen?

> Include description of the expected behaviour.

* What actually happened?

> Include description of the observed behaviour, including actual output,
> screenshots, etc.

# Diagnostic data

## Language

> The program language you are using.

## Output of `vim --version`

> Place the output here, or a link to a [gist][].

## Output of `message`

> Place the output here, or a link to a [gist][].

## OS version, distribution, etc.

> Include system information here.


[gist]: https://gist.github.com/
[readme]: https://github.com/tenfyzhong/CompleteParameter.vim/blob/master/README.md
[faq]: https://github.com/tenfyzhong/CompleteParameter.vim/blob/master/README.md#faq
